// contact me if you need help understanding the functions, xeen
var Ci = Components.interfaces;
var Cc = Components.classes;
var rdr = {
  prefServ: Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService),
  fixup: Cc["@mozilla.org/docshell/urifixup;1"].getService(Ci.nsIURIFixup),
  hist: Cc["@mozilla.org/browser/global-history;2"].getService(Ci.nsIGlobalHistory2),
  // Adds all kinds of observers & injects code in order to clean links
	init: function (all) {    
    window.removeEventListener("load",function() { rdr.init(true); }, false);    
    window.addEventListener("unload", function() { rdr.prefs = null; }, false); 
    
    rdr.prefs=rdr.prefServ.getBranch('extensions.rdr.');
    rdr.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		rdr.prefs.addObserver("", this, false);    
    rdr.updatePrefs();
    
    if(all) {
      document.getElementById("content").addEventListener("click", rdr.catchClick, true);
      document.getElementById("cmd_copyLink").setAttribute("oncommand", "rdr.resetLink();goDoCommand('cmd_copyLink')");

      var context=document.getElementById("contentAreaContextMenu");
      if(context) {
        context.addEventListener("popupshowing", function(event) { rdr.contextMenuCheck(event); }, false);
        context.addEventListener("popuphiding",  function(event) { rdr.contextMenuClean(event); }, false);
      }
      
      var appcontent = document.getElementById("appcontent");
      if(appcontent) {
        appcontent.addEventListener("DOMContentLoaded", rdr.cleanImgs, true);
        appcontent.addEventListener("DOMContentLoaded", rdr.attachMouseOver, true);
      }
      
      // Code injecting functions need to be delayed
      window.setTimeout("rdr.delayedInit();",10);  
    }
	},
  
  delayedInit: function() {  
    // For URLs in the statusbar
    if(nsBrowserStatusHandler) {
      eval("nsBrowserStatusHandler.prototype.setOverLink="+nsBrowserStatusHandler.prototype.setOverLink.toString().replace(
      'link;',
      'unescape(rdr.findLink(rdr.overLink))==link?unescape(rdr.cleanLink(rdr.findLink(rdr.overLink),true)):link;'
      ));
    }    
       
    try {
      // TabMix function "open multiple links". This might change in future versions, so additional checking might be needed
      if(window.openMultipleLinks) {
        eval("openMultipleLinks="+openMultipleLinks.toString().replace(
        'newTab =',
        'nextEpisode.href=rdr.cleanLink(nextEpisode.href,false); newTab ='
        ));
      } 
    } catch(e){}
    
    try {
      // AiO-Gestures should use cleaned links 
      if(window.aioGetHRef) {
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'node.href',
        'rdr.cleanLink(node.href,false);'
        ));
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href"))',
        'rdr.cleanLink(makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href")),false);'
        ));
      }
    } catch(e){}
    
    try {
      // Smart Middle Click shouldn't open links if RDR can do it instead
      if(window.contentAreaClick2) {
        eval("contentAreaClick2="+contentAreaClick2.toString().replace(
        'wrapper = linkNode;',
        'wrapper = linkNode; '+
        'if(wrapper.href!=rdr.cleanLink(wrapper.href,false)) return false;'
        ));
      } 
    } catch(e){}
  },
    
  catchClick: function(aEvt) {
    if (aEvt.button!= 2 && rdr.contentAreaClick(aEvt)) // button=2 == right click
		  aEvt.stopPropagation();
  },
    
  contentAreaClick: function(event) {
    var target = event.target;
  	var linkNode;

  	if (target instanceof HTMLAnchorElement || target instanceof HTMLAreaElement || target instanceof HTMLLinkElement) {
  		if (target.hasAttribute("href")) linkNode = target;
  	} else {
  		linkNode = event.originalTarget;
  		while (linkNode && !(linkNode instanceof HTMLAnchorElement)) linkNode = linkNode.parentNode;        
  		if (linkNode && !linkNode.hasAttribute("href")) linkNode = null;
  	}
        
  	var wrapper = null;
  	if (linkNode) {
  		wrapper = linkNode;

      clean=rdr.cleanLink(wrapper.href,false);
      if(clean==wrapper.href) return false;

      // Add uncleaned link to history as well, so it's displayed as visited
      rdr.addURLToHistory(wrapper.href,linkNode);
      
      rdr.origlinkURL=new Array(wrapper,wrapper.href);
        window.setTimeout("rdr.resetLink();",0);
      
      wrapper.href=clean;
  		handleLinkClick(event, clean, wrapper);  
      return true;
  	}

  	return false;
  },
  
  addURLToHistory: function(url,node) {
    uri = rdr.fixup.createFixupURI(url, 0);
    if (!rdr.hist.isVisited(uri)) {
      rdr.hist.addURI(uri, false, true, null);
      var oldHref = node.getAttribute("href");
      if (typeof oldHref == "string") {
        node.setAttribute("href", "");
        node.setAttribute("href", oldHref);
      }
    }
    return url;
  },
    
  cleanImgs: function(e) {
    var doc = e.originalTarget;
    if(doc.nodeName != "#document" || !rdr.cleanImgsOnLoad || !doc.images || doc.images.length==0) return;
    for(i=0;i<doc.images.length;i++) {
      tmp=doc.images[i].src;
      doc.images[i].src=rdr.cleanLink(doc.images[i].src,false);
      if(tmp!=doc.images[i].src) doc.images[i].setAttribute("origsrc",tmp);
    }
  },
  
  attachMouseOver: function(e) {
    var doc = e.originalTarget;
    if(doc.nodeName != "#document" || doc.links.length==0) return;
    doc.addEventListener("mouseover", rdr.catchMouseOver, true);
  },
  
  catchMouseOver: function(event) {
    // We'll only care for that node when we need to find a link
    rdr.overLink=event.target;
  },
  
  findLink: function(e) {
    while(e && e.docName!="#document") {      
      if(e.href && e.href.length>0) {
        return e.href; 
      }
      e=e.parentNode;
    }
    return false;
  },
   
  updatePrefs: function() {
    rdr.whitelist        = rdr.prefs.getCharPref("whitelist").toLowerCase().split(" ");
    rdr.contextWhitelist = rdr.prefs.getBoolPref("contextmenu.whitelist");
    rdr.contextCopyClean = rdr.prefs.getBoolPref("contextmenu.copyclean");
    rdr.contextOpen      = rdr.prefs.getBoolPref("contextmenu.contextopen");
    rdr.contextOpenIn    = rdr.prefs.getIntPref ("contextmenu.contextopen.in");
    rdr.cleanImgsOnLoad  = rdr.prefs.getBoolPref("cleanImages");
    rdr.statusButton     = rdr.prefs.getBoolPref("statusbutton");
    rdr.enabled          = rdr.prefs.getBoolPref("enabled");
    rdr.debug            = rdr.prefs.getBoolPref("debug");
    
    try {      
      b=document.getElementById('rdr-button');    
      b.setAttribute('isenabled',rdr.enabled);
      b.setAttribute('label',document.getElementById("rdrLocale").getString(rdr.enabled?"rdrDisable":"rdrEnable"));
    } catch(e) {}
     
    b=document.getElementById('rdr-status-button');
    
    if(rdr.statusButton) {
      b.setAttribute('isenabled',rdr.enabled);
      b.setAttribute('hidden','false');
      b.setAttribute('collapsed','false');
    } else {
      b.setAttribute('hidden','true');
      b.setAttribute('collapsed','true');
    } 
  },
    
  contextMenuCheck: function(event) {
    if(event.target.getAttribute('id')!='contentAreaContextMenu' || !gContextMenu) return;
    if(rdr.origlinkURL == null) {
      link=gContextMenu.linkURL;
      isOnList=rdr.isWhitelisted(link);
      cleanedLink=rdr.removeR(link,false);
      containsR=gContextMenu.onLink && (link!=cleanedLink);
      if(containsR) {
        rdr.d('Extracted '+cleanedLink+' from '+link);
        rdr.origlinkURL=new Array(gContextMenu.link,gContextMenu.linkURL,isOnList,cleanedLink);
        if(rdr.enabled && !isOnList) {
          gContextMenu.linkURL=cleanedLink;
          gContextMenu.link.setAttribute("href",cleanedLink);
        }
      }
    } else {
      containsR=true;
      isOnList=rdr.origlinkURL[2];
    }
    rdr.hideById('rdr-copy-clean-link' ,(containsR && rdr.contextCopyClean));
    rdr.hideById('rdr-add-to-list'     ,(containsR && !isOnList && rdr.contextWhitelist));
    rdr.hideById('rdr-remove-from-list',(containsR &&  isOnList && rdr.contextWhitelist));
    rdr.hideById('rdr-open-cleaned'    ,(containsR && (!rdr.enabled || isOnList) && rdr.contextOpen));
    rdr.hideById('rdr-open-uncleaned'  ,(containsR && (rdr.enabled && !isOnList) && rdr.contextOpen));    
  },
  
  hideById: function(id,stat) {
    document.getElementById(id).hidden =!stat;
  },
  
  contextMenuClean: function(event) {
    if(event.target.getAttribute('id')!='contentAreaContextMenu') return;
    rdr.resetLink();
  },
  
  resetLink: function() {
    if(!rdr.origlinkURL) return;
    rdr.d('Cleaning saved Link');
    rdr.origlinkURL[0].setAttribute('href',rdr.origlinkURL[1]);
    rdr.origlinkURL=null;
  },
  
  addLinkToList: function(link) {
    host=rdr.getHost(unescape(link));
    rdr.d('Added "'+host+' to list (from '+link+' )');
    if(!link || !host) return;
    wl=rdr.prefs.getCharPref("whitelist");
    if(wl.length>0) wl=wl+' ';
    rdr.prefs.setCharPref('whitelist',(wl+host).toLowerCase());
  },
  
  removeLinkFromList: function(link) {
    if(!link || !link.length) return;
    var filter=rdr.isWhitelisted(unescape(link),true);    
    var wl=' '+rdr.prefs.getCharPref("whitelist")+' ';

    if(filter) {
      rdr.d('Removing '+filter+' from list (from '+link+' )');
      rdr.prefs.setCharPref('whitelist',(wl.replace(' '+filter+' ',' ')).replace(/^\s*|\s*$/g,""));
      return;
    }
    
    rdr.d('Removing '+link+' from list failed; no matching host found ('+host.toString()+')');
  },
  
  copyCleanLink: function() {
    var oCB = Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
    oCB.copyString(rdr.origlinkURL[3]);
  },
  
  openLink: function(link) {
    switch (rdr.contextOpenIn) {
      case 0: // here
        loadOneOrMoreURIs(link);
        break;
      case 2: // new window
        window.open(link);
        break;
      default: // new tab
        var t = gBrowser.addTab(link);
        if(!rdr.prefServ.getBoolPref('browser.tabs.loadInBackground')) {
          gBrowser.selectedTab = t;
          content.focus();
        }
    }
  },
  
  cleanLink: function(link,app) {
    if(rdr.isWhitelisted(link) || !rdr.enabled) return link;
    l=rdr.removeR(link,app);
    if(l!=link && !app) rdr.d('Extracted '+l+' from '+link);
    return l;
  },
  
  isWhitelisted: function(link,returnFilter) {    
    if(rdr.whitelist.length==0 || link.length==0 || !link) return false;
    try {  var link=unescape(link.toLowerCase()); } catch(e) { this.d(link+' FEHLER: '+e); } 
    for (var i in rdr.whitelist) {
      var listParts=rdr.whitelist[i].split('*');
      var matches=true;
      z=0;
      for (var j in listParts) {
        var x=link.indexOf(listParts[j]);
        if(x==-1 || x<z) { // not found or not in correct order
          matches=false;
          break;
        } 
        z=x+listParts[j].length;        
      }
      if(matches) {
        if(returnFilter) return rdr.whitelist[i];
        rdr.d('Link '+link+' whitelisted by '+rdr.whitelist[i]);
        return true;
      }
    }
    return false;  
  },
    
  getHost: function (link) {
    var url=link.match(/\/\/(.*?)(?:\/|\?)/);
    return (url ? url[1] : link).toLowerCase();
  },
  
  removeR: function(link,app) {
    if(app) a='RDR: '; else a='';
    //rdr.d('Cleaning: '+link);
    // Huge thanks to jumplink!
    // uggc|sgc|uggcf matches rot13 encoded URLs
  	var re = new RegExp;
  	re.compile("\\S\\/.*((?:http|ftp|https|uggc|sgc|uggcf)(?:(?:(?:%3a|%253a)[^&]+)|(?:[:].+)))", "gi");
  	if((r = link.match(re))) {
  		var ret = unescape(RegExp.$1);
      if(ret.indexOf('www.')==0) ret='http://'+ret;
  		if (ret.indexOf('%253a')) {
  			if (link.toLowerCase().indexOf('javascript') == 0) {
  				if (ret.match(/(.+?)[^-%a-z0-9:\/&]+$/gi))
  					return a+rdr.deRot13(unescape(RegExp.$1));
  				else
  					return a+rdr.deRot13(ret);		
  			}
  			return a+rdr.deRot13(unescape(ret));
  		} else {
  			return a+rdr.deRot13(ret);
  		}
  	}
  	
  	if (link.toLowerCase().indexOf('javascript') == 0) {
  		link2 = link.substr(link.indexOf('http'));
  		if((r = link2.match(re))) {
  			var ret = unescape(RegExp.$1);
         if(ret.indexOf('www.')==0) ret='http://'+ret;
  			if (ret.indexOf('%253a')) {
  				return a+rdr.deRot13(unescape(ret));
  			} else {
  				return a+rdr.deRot13(ret);
  			}
  		}
  	}
    return link;
  },
		
	deRot13: function(s){
    s=s.replace(/&amp;/g,'&');
    sb=s.toLowerCase();
    if(!(sb.indexOf('uggc:')>=0 || sb.indexOf('sgc:')>=0 || sb.indexOf('uggcf:')>=0)) return s;
    
    var list ='abcdefghijklmnopqrstuvwxyzabcdefghijklm';
    var list2='ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLM';
    var r='';
    for (var x = 0; x <= s.length; x++) {
      rot13 = s.substring(x, x+1);
      if (rot13 >= 'a' && rot13 <= 'z') 
        rot13 = list.charAt(list.indexOf(rot13) + 13);
      else if (rot13 >= 'A' && rot13 <= 'Z') 
        rot13 = list2.charAt(list.indexOf(rot13) + 13);
      r+=rot13;
    }
    
		return r;
  },	
  
  observe: function (subject, topic, data) {
		if (topic == "nsPref:changed") {
			rdr.updatePrefs();
		}
	},
  
  // MetaData Functions
  showAddRem: function(add,rem,id) {
    rdr.hideById("rdr-add-to-list-"+id,add);
    rdr.hideById("rdr-remove-from-list-"+id,rem);
  },
  
	d: function(t) {
	  if(rdr.debug) Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage('rdr: '+t);
  }	
}